mod btrfs_structs;

use memmap2::Mmap;
use std::fs::File;
use rouille::Request;
use rouille::Response;
use btrfs_structs::{ItemType, ParseBin, Key, Item, Leaf, NodeHeader};

//const ACTIVE_NODES: &'static[usize] = &[0x14000, 0x18000, 0x1c000, 0x20000, 0x28000, 0x2c000, 0x3c000, 0x40000];

fn main() -> Result<(), std::io::Error> {
	let file = File::open("../image")?;
	let image = unsafe { Mmap::map(&file)? };

//	println!("{:#?}", Leaf::parse(&image[0x253c000..0x2540000]));
	println!("{:#?}", Leaf::parse(&image[0x1d04000..0x1d08000]));

	Ok(())
}

/*
fn main() -> Result<(), std::io::Error> {
	let file = File::open("../image")?;
	let image = unsafe { Mmap::map(&file)? };

	let addr = AddressTranslation::new(&image);

	rouille::start_server("127.0.0.1:8080", move |request| {
		http_main_list(&image, &addr, request)
	});
}

fn http_main_boxes(image: &[u8], addr: &AddressTranslation, req: &Request) -> Response {
	let chunk_offset = 0x02500000;
	let nodes_in_chunk = 2048;
	let mut result = String::new();

	result.push_str("<body><table style=\"margin: 0 auto;\">\n<tr>\n");

	for i in 0..nodes_in_chunk {
		if i % 64 == 0 {
			result.push_str("</tr>\n<tr>\n");
		}

		let node = read_node(&image, chunk_offset + i*0x4000);

		let active = node.generation > 0 && ACTIVE_NODES.contains(&(i*0x4000));

		let newbox = format!("<td style=\"{}\"></td>\n",
							 if active {
								 "height:10px;width:10px;padding:0;background:black;"
							 } else {
								 "height:10px;width:10px;padding:0;background:lightgray;"
							 });
		result.push_str(&newbox);
	}

	result.push_str("</tr>\n</table></body>");

	Response::html(result)
}

fn http_main_list(image: &[u8], addr: &AddressTranslation, req: &Request) -> Response {
	let chunk_offset = 0x02500000;
	let nodes_in_chunk = 2048;
	let mut result = String::new();

	result.push_str("<body>\n");

	for i in 0..nodes_in_chunk {
		let node = read_node(&image, chunk_offset + i*0x4000);

		let active = ACTIVE_NODES.contains(&(i*0x4000));
		let style = if active { "color:black;" } else { "color:lightgray;" };

		let newline = format!("<p style=\"{}\">{:x} {} {} {}\n<ul>\n",
							  style,
							  chunk_offset + i*0x4000,
							  node.level,
							  node.items.len(),
							  node.generation);
		result.push_str(&newline);

		for item in &node.items {
			let newline = format!("<li style=\"{}\">{:016x} {:?} {:x}</li>\n",
								  style,
								  item.key.key_id,
								  item.key.key_type,
								  item.key.key_offset);
			result.push_str(&newline);
		}

		result.push_str("</ul></p>\n");
	}

	Response::html(result)
}
*/

/*
fn read_node_log(image: &[u8], trans: &AddressTranslation, log: u64) -> Option<Box<BtrfsNode>> {
	let phys = trans.to_phys(log)?;
	Some(read_node(image, phys as usize))
}

fn read_node(image: &[u8], offset: usize) -> Box<BtrfsNode> {
	let mut result = Box::new(BtrfsNode {
		csum:           FromBytes::get(image, offset),
		fs_uid:         FromBytes::get(image, offset + 0x20),
		bytenr:         FromBytes::get(image, offset + 0x30),
		flags:          FromBytes::get(image, offset + 0x38),
		chunk_tree_uid: FromBytes::get(image, offset + 0x40),
		generation:     FromBytes::get(image, offset + 0x50),
		owner:          FromBytes::get(image, offset + 0x58),
		nritems:        FromBytes::get(image, offset + 0x60),
		level:          FromBytes::get(image, offset + 0x64),
		items: Vec::new(),
	});

	// assuming leaf for now

	for i in 0..result.nritems as usize {
		let key_id: u64 =       FromBytes::get(image, offset + 0x65 + i*0x19);
		let key_type_code: u8 = FromBytes::get(image, offset + 0x65 + i*0x19 + 0x08);
		let key_offset: u64 =   FromBytes::get(image, offset + 0x65 + i*0x19 + 0x09);
		let data_offset: u32 =  FromBytes::get(image, offset + 0x65 + i*0x19 + 0x11);
		let data_size: u32 =    FromBytes::get(image, offset + 0x65 + i*0x19 + 0x15);

		let key_type = itemtype_from_code(key_type_code);
		let data_slice = &image[(offset + 0x65 + data_offset as usize) .. (offset + 0x65 + data_offset as usize + data_size as usize)];

		let value = match key_type {
			BtrfsItemType::BlockGroup => BtrfsValue::BlockGroup(FromBytes::get(data_slice, 0)),
			BtrfsItemType::Metadata => BtrfsValue::Extent(FromBytes::get(data_slice, 0)),
			BtrfsItemType::Chunk => BtrfsValue::Chunk(FromBytes::get(data_slice, 0)),
			BtrfsItemType::Root => BtrfsValue::Root(FromBytes::get(data_slice, 0)),
			_ => BtrfsValue::Unknown(Vec::from(data_slice)),
		};

		result.items.push(BtrfsItem {
			key: BtrfsKey {
				key_id: key_id,
				key_type: key_type,
				key_offset: key_offset,
			},
			value: value,
		});
	}

	result
}
*/
